{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": [
    "class edgeList:\n",
    "    def __init__(self, inList):\n",
    "        self.edges=[]\n",
    "        for e in inList:\n",
    "            v1 = e.split(\" \")[0]\n",
    "            v2 = e.split(\" \")[1]\n",
    "            self.edges.append( (v1, v2) )\n",
    "\n",
    "def getVertices(el):\n",
    "    \n",
    "    out = set() # Sets allow no duplicates\n",
    "    for edge in el.edges:\n",
    "        out.add(edge[0])\n",
    "        out.add(edge[1])\n",
    "    return list(out)\n",
    "\n",
    "def getEdges(el, v): # A single vertex (I want all edges that touch that vertex)\n",
    "    out = set()\n",
    "    el.edges #is my ****LIST*** of tuples as edges\n",
    "    for edge in el.edges: # Find vertex v\n",
    "\n",
    "        #NOTE: I manually changed the output of getEdges!\n",
    "        if edge[0] == v:\n",
    "            out.add((v, edge[1]))\n",
    "        elif edge[1] == v:\n",
    "            out.add((edge[0], v))\n",
    "\n",
    "    return list(out)\n",
    "\n",
    "def areAdjacent(el, v1, v2):\n",
    "    out = set()\n",
    "    el.edges #is my ****LIST*** of tuples as edges\n",
    "    for edge in el.edges: # Find vertex v\n",
    "        if edge[0]==v1 and edge[1]==v2:\n",
    "            return True\n",
    "        if edge[1]==v1 and edge[0]==v2:\n",
    "            return True\n",
    "    return False\n",
    "\n",
    "def insertEdge(el, v1, v2):\n",
    "    pass\n",
    "\n",
    "'''\n",
    "u v\n",
    "u w\n",
    "v w\n",
    "w z\n",
    "'''\n",
    "\n",
    "inList = [\"u v\", \"u w\", \"v w\", \"w z\"]\n",
    "out = edgeList(inList)\n",
    "print(out.edges)\n",
    "print(getVertices(out))\n",
    "print(getEdges(out, \"v\"))\n",
    "print(areAdjacent(out, \"w\", \"v\"))"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": []
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "z: 0\n",
      "v: 1\n",
      "u: 2\n",
      "w: 3\n",
      "{'z': 0, 'v': 1, 'u': 2, 'w': 3}\n",
      "[[0, 0, 0, 1], [0, 0, 1, 1], [0, 1, 0, 1], [1, 1, 1, 0]]\n",
      "['z', 'v', 'u', 'w']\n"
     ]
    },
    {
     "data": {
      "text/plain": [
       "0"
      ]
     },
     "execution_count": 6,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "class adjMatrix:\n",
    "    def __init__(self, inList=[]): # an input list of edges [ (A, B), (B, C), ...]\n",
    "        self.vertices={} #dictionary\n",
    "        self.edges=[] # matrix \n",
    "\n",
    "        # Make our vertex dictionary\n",
    "        vertSet = set() # Sets allow no duplicates\n",
    "        for edge in inList:\n",
    "            vertSet.add(edge[0])\n",
    "            vertSet.add(edge[1])\n",
    "        #vertSet has all vertices\n",
    "        #vertex w/ number\n",
    "\n",
    "        # Define an order!\n",
    "        # Build our dictionary\n",
    "        count = 0\n",
    "        for v in vertSet:\n",
    "            print(\"{}: {}\".format(v, count))\n",
    "            self.vertices[v]=count # Add it to my dictionary\n",
    "            count+=1\n",
    "\n",
    "        # Make our edge matrix (empty)\n",
    "        for i in range(len(self.vertices.keys())): # N iterations (for n vertices)\n",
    "            self.edges.append([0] * len(self.vertices.keys()))\n",
    "        \n",
    "        #print(self.edges)\n",
    "\n",
    "        # Fill in the edge matrix\n",
    "        for edge in inList:\n",
    "            v1 = edge[0]\n",
    "            v2 = edge[1]\n",
    "\n",
    "            i1 = self.vertices[v1]\n",
    "            i2 = self.vertices[v2]\n",
    "\n",
    "            self.edges[i1][i2]=1 # Gives us edge u v \n",
    "            self.edges[i2][i1]=1 # Gives us edge v u  \n",
    "\n",
    "# Return a list of all vertices in my adjmatrix\n",
    "def getVertices(inGraph):\n",
    "    return list(inGraph.vertices.keys())\n",
    "\n",
    "# Return a list of tuples for every edge that includes v\n",
    "def getEdges(inGraph, v):\n",
    "    out = []\n",
    "    # 1) Get matching index (for row in question)\n",
    "    ind = inGraph.vertices[v] # is written EXCLUSIVELY to tell me where to look in edge matrix\n",
    "    # 2) Loop through row and look for 1 values (THESE ARE MY EDGES)\n",
    "    for u in inGraph.vertices.keys():\n",
    "        ind2 = inGraph.vertices[u] # Now I have two index values\n",
    "        if inGraph.edges[ind][ind2]==1: # I have the edge u, v (or v, u)\n",
    "            out.append( (u, v) ) # Also have put (v, u)\n",
    "    # 3) Return tuples corresponding to those u, v pairs\n",
    "\n",
    "def areAdjacent(inGraph, v1, v2):\n",
    "    # get my matching indices\n",
    "    i1 = inGraph.vertices[v1]\n",
    "    i2 = inGraph.vertices[v2]\n",
    "    return inGraph.edges[i1][i2]\n",
    "\n",
    "inList = [(\"u\", \"v\"),(\"u\", \"w\"),(\"v\", \"w\"),(\"w\", \"z\")]\n",
    "out = adjMatrix(inList)\n",
    "print(out.vertices) # Expected: {'u': 0, 'v': 1, 'w': 2, 'z': 3}\n",
    "print(out.edges) # Expected: [[0, 1, 1, 0], [1, 0, 1, 0], [1, 1, 0, 1], [0, 0, 1, 0]]\n",
    "print(getVertices(out))\n",
    "\n",
    "areAdjacent(out, \"z\", \"v\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 16,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "True"
      ]
     },
     "execution_count": 16,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "class adjList:\n",
    "    def __init__(self, inList=[]):\n",
    "        # The vertices are the keys in the edge map\n",
    "        self.edges={}\n",
    "\n",
    "        for edge in inList:\n",
    "            v1 = edge[0]\n",
    "            v2 = edge[1]\n",
    "            #print(edge)\n",
    "            if v1 in self.edges: # If my vertex already exists\n",
    "                self.edges[v1].append(v2)\n",
    "            else: \n",
    "                self.edges[v1] = [v2] # If my vertex doesnt exist (this edge is the FIRST I saw)\n",
    "            \n",
    "            if v2 in self.edges:\n",
    "                self.edges[v2].append(v1)\n",
    "            else:\n",
    "                self.edges[v2] = [v1]\n",
    "            \n",
    "            #print(self.edges)\n",
    "            \n",
    "\n",
    "# Output is a list of all vertices\n",
    "def getVertices(inGraph): # Input is an adjacency list\n",
    "    return list(inGraph.edges.keys())\n",
    "\n",
    "# Output is a list of tuples containing edges\n",
    "def getEdges(inGraph, v): # Input is a vertex key (label)\n",
    "    #print(inGraph.edges[v])\n",
    "    out = [] # I want to return a list\n",
    "    for edge in inGraph.edges[v]: # What is the worst case # of edges? O(n)\n",
    "        out.append( (v, edge))\n",
    "\n",
    "    return out # I want to return a list of tuples\n",
    "\n",
    "# A boolean -- if the edge v1, v2 exists\n",
    "def areAdjacent(inGraph, v1, v2): # Two input vertices (as key labels)\n",
    "    # How do I know if the edge exists?\n",
    "    if v2 in inGraph.edges[v1]: # Built in searches are your friends! # This is also O(n)\n",
    "        return True\n",
    "    return False\n",
    "\n",
    "        \n",
    "\n",
    "inList = [(\"u\", \"v\"),(\"u\", \"w\"),(\"v\", \"w\"),(\"w\", \"z\")]\n",
    "out = adjList(inList)\n",
    "areAdjacent(out, \"v\", \"u\")\n",
    "#getEdges(out, \"v\") # [(u, v), (w, v)] (this could be flipped -- v, u or v, w)\n",
    "#print(out.edges) # Expected: {'u': ['v', 'w'], 'v': ['u', 'w'], 'w': ['u', 'v', 'z'], 'z': ['w']}"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.1"
  },
  "orig_nbformat": 4
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
